n个六面的骰子,扔一次之后和为k的概率是多少?

题目要求:n个六面的骰子,扔一次之后和为k的概率是多少?给定骰子数量n和骰子的点数之和k,求概率res。

思路:动态规划dp。

问题分析:每个骰子的点数都是1~6,因此n个骰子的总点数和的范围是n,6n,需要计算点数之和恰好等于k的方案数。

1.确定dp数组及其下标的含义:dpij表示使用i个骰子,总点数和为j的方案数。

2.确定递推公式:可知i个骰子的情况可以由i - 1个骰子的情况推出。

(1)因此dpij = dpi - 1j - 6 + dpi - 1\[j - 5 + dpi - 1j - 4 + dpi - 1j - 3 + dpi - 1j - 2 + dpi - 1j - 1。

(2)即:dpij = dpi - 1j - v for v = 1 to 6 。

3.dp数组如何初始化:dp00 = 1,表示使用0个骰子,总点数和为0的方案数为1。在这里没有实际意义,只用作dp数组的初始化。

4.确定遍历顺序:本题相当于分组背包问题。有n个组(每组对应一个骰子),每组有6个物品(点数1~6),每组必须且只能选1个物品,求恰好凑成总重量k的方案数。因此在使用二维数组时,组内物品的遍历顺序无所谓。

附代码:

java 复制代码
class Solution {
    public String probabilityOfSum(int n, int k) {
        // 如果 k 不在可能范围内,概率为 0
        if (k < n || k > 6 * n) {
            return "0";
        }

        // dp[i][s]:i 个骰子,点数和为 j 的方案数
        long[][] dp = new long[n + 1][6 * n + 1];
        dp[0][0] = 1;

        // i个骰子
        for (int i = 1; i <= n; i++) {
            // j表示i的骰子可能的点数和,范围为[i,6 * i]
            for (int j = i; j <= 6 * i; j++) {
                // v表示第i个骰子可选点数,范围为[1,6]
                for (int v = 1; v <= 6; v++) {
                    // j - v要大于等于0,因为第i个骰子的可选的点数一定不能超过点数和,否则需要排除
                    if (j - v >= 0) {
                        // 因为v会从1-6中取值,所以要把这6种可能累加
                        dp[i][j] += dp[i - 1][j - v];
                    }
                }
            }
        }

        // 总方案数 = 6^n
        long total = (long) Math.pow(6, n);
        // 可选方案数 = dp[n][k]
        long ways = dp[n][k];

        // 约分
        long g = gcd(ways, total);
        ways /= g;
        total /= g;

        return ways + "/" + total;
    }

    // 递归求最大公约数(欧几里得算法,即辗转相除法)
    private long gcd(long a, long b) {
        return b == 0 ? a : gcd(b, a % b);
    }
}

ACM模式:

java 复制代码
import java.util.Scanner;

class Solution {
    public String probabilityOfSum(int n, int k) {
        // 如果 k 不在可能范围内,概率为 0
        if (k < n || k > 6 * n) {
            return "0";
        }

        // dp[i][s]:i 个骰子,点数和为 j 的方案数
        long[][] dp = new long[n + 1][6 * n + 1];
        dp[0][0] = 1;

        // i个骰子
        for (int i = 1; i <= n; i++) {
            // j表示i的骰子可能的点数和,范围为[i,6 * i]
            for (int j = i; j <= 6 * i; j++) {
                // v表示第i个骰子可选点数,范围为[1,6]
                for (int v = 1; v <= 6; v++) {
                    // j - v要大于等于0,因为第i个骰子的可选的点数一定不能超过点数和,否则需要排除
                    if (j - v >= 0) {
                        // 因为v会从1-6中取值,所以要把这6种可能累加
                        dp[i][j] += dp[i - 1][j - v];
                    }
                }
            }
        }

        // 总方案数 = 6^n
        long total = (long) Math.pow(6, n);
        // 可选方案数 = dp[n][k]
        long ways = dp[n][k];

        // 约分
        long g = gcd(ways, total);
        ways /= g;
        total /= g;

        return ways + "/" + total;
    }

    // 递归求最大公约数(欧几里得算法,即辗转相除法)
    private long gcd(long a, long b) {
        return b == 0 ? a : gcd(b, a % b);
    }
}

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // 读取骰子个数 n 和目标和 k
        int n = scanner.nextInt();
        int k = scanner.nextInt();

        // 计算结果
        Solution solution = new Solution();
        String result = solution.probabilityOfSum(n, k);
        System.out.println(result);

        scanner.close();
    }
}
相关推荐
zyl76515 小时前
FlashAttention 详解:从 GPU 硬件、普通 Attention 到分块计算与 Online Softmax
算法
爱读书的小胖18 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌18 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F19 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_3077791319 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
tomwang032219 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!19 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
2501_9269783320 小时前
人机通信协议--人和机器之间的交互想象
人工智能·经验分享·算法·ai写作
行者全栈架构师20 小时前
【鸿蒙心迹】互动卡片全链路——把核心功能放到桌面(FormKit 实战)(HarmonyOS 7.x)
前端·算法·架构
无定义_20 小时前
10.11日常训练
算法